package com.testsound;

import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder;
import java.io.IOException;
import java.io.PipedOutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Capture implements Runnable {

    int nbPoint = 0;
    boolean stopC;
    byte[] serial;
    int minBuffer = AudioRecord.getMinBufferSize(44100,
            AudioFormat.CHANNEL_IN_MONO, AudioFormat.ENCODING_PCM_16BIT);
    static final int FACTOR = 2;
    int bufferSize = 88200;
    PipedOutputStream pOStream;
    AudioRecord record;

    public PipedOutputStream getSender() {

        return pOStream;
    }

    public void startCapture() {

        record = new AudioRecord(MediaRecorder.AudioSource.DEFAULT,
                44100, AudioFormat.CHANNEL_IN_MONO,
                AudioFormat.ENCODING_PCM_16BIT, bufferSize);

        pOStream = new PipedOutputStream();
        Thread th = new Thread(this);
        th.start();

    }

    public void setStopCapture(boolean stop) {

        stopC = stop;
    }

    /*
     * producteur
     */
    public void run() {

        int y = 0;
        byte[] point = new byte[bufferSize];
        record.startRecording();
        
        while (stopC == false) {

            nbPoint = record.read(point, 0, point.length);
            
            try {
                for (int i = 0; i < point.length; i++) {

                    pOStream.write(point[i]);
                }
            } catch (IOException ex) {
                Logger.getLogger(Capture.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        try {
            Thread.sleep(1000);
            pOStream.close();
        } catch (InterruptedException ex) {
            Logger.getLogger(Capture.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Capture.class.getName()).log(Level.SEVERE, null, ex);
        }


        record.stop();
        record.release();
    }
}
